//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Fri Feb 10 19:25:14 2017
// Version: PolarFire EAP4 12.100.7.18
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// EPCS_TX_RX
module EPCS_TX_RX(
    // Inputs
    LANE0_PCS_ARST_N,
    LANE0_RXD_N_0,
    LANE0_RXD_P_0,
    REF_CLK_PAD_N_0,
    REF_CLK_PAD_P_0,
    clr_err_counter,
    error_inject,
    // Outputs
    LANE0_RX_VAL,
    LANE0_TXD_N_0,
    LANE0_TXD_P_0,
    error_count,
    error_out,
    lock
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input        LANE0_PCS_ARST_N;
input        LANE0_RXD_N_0;
input        LANE0_RXD_P_0;
input        REF_CLK_PAD_N_0;
input        REF_CLK_PAD_P_0;
input        clr_err_counter;
input        error_inject;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output       LANE0_RX_VAL;
output       LANE0_TXD_N_0;
output       LANE0_TXD_P_0;
output [5:0] error_count;
output       error_out;
output       lock;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire          clr_err_counter;
wire   [15:0] count_gen_0_data_out;
wire   [1:0]  count_gen_0_k_out;
wire          count_gen_0_rxslip_0;
wire   [5:0]  error_count_net_0;
wire          error_inject;
wire          error_out_net_0;
wire          LANE0_PCS_ARST_N;
wire          LANE0_RX_VAL_net_0;
wire          LANE0_RXD_N_0;
wire          LANE0_RXD_P_0;
wire          LANE0_TXD_N_0_net_0;
wire          LANE0_TXD_P_0_net_0;
wire          lock_net_0;
wire          REF_CLK_PAD_N_0;
wire          REF_CLK_PAD_P_0;
wire          SD1_0_FAB_REF_CLK;
wire   [1:0]  SD1_0_LANE0_8B10B_RX_K;
wire          SD1_0_LANE0_RX_CLK_G;
wire   [15:0] SD1_0_LANE0_RX_DATA;
wire          SD1_0_LANE0_RX_VAL;
wire          SD1_0_LANE0_TX_CLK_G;
wire          LANE0_RX_VAL_net_1;
wire          LANE0_TXD_P_0_net_1;
wire          LANE0_TXD_N_0_net_1;
wire          error_out_net_1;
wire          lock_net_1;
wire   [5:0]  error_count_net_1;
//--------------------------------------------------------------------
// TiedOff Nets
//--------------------------------------------------------------------
wire   [3:0]  LANE0_TX_DISPFNC_const_net_0;
//--------------------------------------------------------------------
// Constant assignments
//--------------------------------------------------------------------
assign LANE0_TX_DISPFNC_const_net_0 = 4'h0;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign LANE0_RX_VAL_net_1  = LANE0_RX_VAL_net_0;
assign LANE0_RX_VAL        = LANE0_RX_VAL_net_1;
assign LANE0_TXD_P_0_net_1 = LANE0_TXD_P_0_net_0;
assign LANE0_TXD_P_0       = LANE0_TXD_P_0_net_1;
assign LANE0_TXD_N_0_net_1 = LANE0_TXD_N_0_net_0;
assign LANE0_TXD_N_0       = LANE0_TXD_N_0_net_1;
assign error_out_net_1     = error_out_net_0;
assign error_out           = error_out_net_1;
assign lock_net_1          = lock_net_0;
assign lock                = lock_net_1;
assign error_count_net_1   = error_count_net_0;
assign error_count[5:0]    = error_count_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------count_check
count_check count_check_0(
        // Inputs
        .reset_n         ( SD1_0_LANE0_RX_VAL ),
        .clk             ( SD1_0_LANE0_RX_CLK_G ),
        .sys_clk         ( SD1_0_FAB_REF_CLK ),
        .rx_val          ( SD1_0_LANE0_RX_VAL ),
        .clr_err_counter ( clr_err_counter ),
        .k_in            ( SD1_0_LANE0_8B10B_RX_K ),
        .data_in         ( SD1_0_LANE0_RX_DATA ),
        // Outputs
        .error_out       ( error_out_net_0 ),
        .lock            ( lock_net_0 ),
        .error_count     ( error_count_net_0 ) 
        );

//--------count_gen
count_gen count_gen_0(
        // Inputs
        .reset_n      ( LANE0_RX_VAL_net_0 ),
        .clk          ( SD1_0_LANE0_TX_CLK_G ),
        .error_inject ( error_inject ),
        .rxval        ( SD1_0_LANE0_RX_VAL ),
        .rxdata       ( SD1_0_LANE0_RX_DATA ),
        // Outputs
        .rxslip       ( count_gen_0_rxslip_0 ),
        .data_out     ( count_gen_0_data_out ),
        .k_out        ( count_gen_0_k_out ) 
        );

//--------SD1
SD1 SD1_0(
        // Inputs
        .LANE0_RXD_P              ( LANE0_RXD_P_0 ),
        .LANE0_RXD_N              ( LANE0_RXD_N_0 ),
        .LANE0_PCS_ARST_N         ( LANE0_PCS_ARST_N ),
        .LANE0_PMA_ARST_N         ( LANE0_PCS_ARST_N ),
        .LANE0_RX_SLIP            ( count_gen_0_rxslip_0 ),
        .REF_CLK_PAD_P            ( REF_CLK_PAD_P_0 ),
        .REF_CLK_PAD_N            ( REF_CLK_PAD_N_0 ),
        .LANE0_TX_DATA            ( count_gen_0_data_out ),
        .LANE0_8B10B_TX_K         ( count_gen_0_k_out ),
        .LANE0_TX_DISPFNC         ( LANE0_TX_DISPFNC_const_net_0 ),
        // Outputs
        .LANE0_TXD_P              ( LANE0_TXD_P_0_net_0 ),
        .LANE0_TXD_N              ( LANE0_TXD_N_0_net_0 ),
        .LANE0_RX_READY           ( LANE0_RX_VAL_net_0 ),
        .LANE0_RX_VAL             ( SD1_0_LANE0_RX_VAL ),
        .LANE0_RX_IDLE            (  ),
        .LANE0_TX_CLK_STABLE      (  ),
        .LANE0_TX_CLK_G           ( SD1_0_LANE0_TX_CLK_G ),
        .LANE0_RX_CLK_G           ( SD1_0_LANE0_RX_CLK_G ),
        .DIV_CLK                  (  ),
        .FAB_REF_CLK              ( SD1_0_FAB_REF_CLK ),
        .LANE0_RX_DATA            ( SD1_0_LANE0_RX_DATA ),
        .LANE0_8B10B_RX_K         ( SD1_0_LANE0_8B10B_RX_K ),
        .LANE0_RX_CODE_VIOLATION  (  ),
        .LANE0_RX_DISPARITY_ERROR (  ) 
        );


endmodule
